<?
/*
 * Copyright (c) 2008, Andrea Marchesini baku@autistici.org
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the <organization> nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY <copyright holder> ''AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL <copyright holder> BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

require_once("config.php");

/* DB connection */
if(!($db=mysql_connect($database['server'], $database['user'], 
                       $database['password'], $database['port'])) || 
   !mysql_select_db($database['database'], $db)) {
  echo mysql_error($db);
  return;
}

/* Header: */
header("Content-type: application/xml");
echo "<?xml version='1.0' encoding='utf-8'?>\n\n";
echo "<scookies version=\"0.1\">\n";

/* IP checking: */
if (check_ip($_SERVER["REMOTE_ADDR"]) == false) {
  echo "  <status>Query too fast</status>\n";
  echo "</scookies>\n";
  return;
}   

/* Parsing: */
if(!($data=scookies_parser())) {
  echo "  <status>Incompatible request</status>\n";
  echo "</scookies>\n";
  return;
}

/* bla bla bla... */
if($data['suggest']==true && $data['suggest_host'] && $data['suggest_name']) {
  mysql_query("INSERT INTO scookies_suggest VALUES(" .
              "\"" . mysql_escape_string($data['suggest_host']) . "\", " .
              "\"" . mysql_escape_string($data['suggest_name']) . "\")");
}

for($i=0; $i<count($data['requests']); $i++) {
  $request=$data['requests'][$i];

  $ret = mysql_query("SELECT count(*) FROM scookies WHERE " .
                     "name = \"" . mysql_escape_string($request['name']) . "\" and " .
                     "host = \"" . mysql_escape_string($request['host']) . "\" and " .
                     "path = \"" . mysql_escape_string($request['path']) . "\" and " .
                     "expires = \"" . mysql_escape_string($request['expires']) . "\" and " .
                     "secure = \"" . mysql_escape_string($request['secure']) . "\"");

  $row = mysql_fetch_array($ret);

  if($row[0] > 0) {
    $ret = mysql_query("SELECT * FROM scookies WHERE " .
                       "name = \"" . mysql_escape_string($request['name']) . "\" and " .
                       "host = \"" . mysql_escape_string($request['host']) . "\" and " .
                       "path = \"" . mysql_escape_string($request['path']) . "\" and " .
                       "expires = \"" . mysql_escape_string($request['expires']) . "\" and " .
                       "secure = \"" . mysql_escape_string($request['secure']) . "\" " .
                       "limit " . rand(0, $row[0] - 1) . ", 1");

    $row = mysql_fetch_array($ret);

    echo "  <request>\n";
    echo "    <name>" . htmlentities($row['name']) . "</name>\n";
    echo "    <value>" . htmlentities($row['value']) . "</value>\n";
    echo "    <host>" . htmlentities($row['host']) . "</host>\n";
    echo "    <path>" . htmlentities($row['path']) . "</path>\n";
    echo "    <expires>" . htmlentities($row['expires']) . "</expires>\n";
    echo "    <secure>" . htmlentities($row['secure']) . "</secure>\n";
    echo "  </request>\n";
  }

  mysql_query("INSERT INTO scookies VALUES(" .
              "\"" . mysql_escape_string($request['name']) . "\", " .
              "\"" . mysql_escape_string($request['value']) . "\", " .
              "\"" . mysql_escape_string($request['host']) . "\", " .
              "\"" . mysql_escape_string($request['path']) . "\", " .
              "\"" . mysql_escape_string($request['expires']) . "\", " .
              "\"" . mysql_escape_string($request['secure']) . "\")");
}

if($data['requestRegex']) {
  echo "<requestRegex>{";

  $ret = mysql_query("SELECT * FROM scookies_regex");
  $i=0;

  for($i=0; $result=mysql_fetch_array($ret); $i++) {
    if($i!=0)
      echo ",\n";

    echo "\"" . $i ."\" : { \"host\" : \"" . 
         mysql_escape_string($result['host']) . 
	 "\", \"name\" : \"" .
	 mysql_escape_string($result['name']) .
	 "\"}";
  }

  echo "}</requestRegex>\n";
}

echo "</scookies>\n";

function scookies_parser() {
  global $HTTP_RAW_POST_DATA;

  $parser=xml_parser_create();

  if(!(xml_parse_into_struct($parser, $HTTP_RAW_POST_DATA, $vals, $index))) {
    xml_parser_free($parser);
    return null;
  }
  
  $data['requests']=array();
  $data['requestRegex']=false;
  $data['suggest']=false;
  $request=null;

  for($i=0;$i<count($vals);$i++) {
    if($vals[$i]['level']=='1' && $vals[$i]['type']=='open' &&
       $vals[$i]['tag']!="SCOOKIES") {
      xml_parser_free($parser);
      return null;
    }

    else if($vals[$i]['level']=='2' && $vals[$i]['tag']=="REQUESTREGEX") {
      $data['requestRegex']=true;
    }

    else if($vals[$i]['level']=='2' && $vals[$i]['type']=='close' &&
            $vals[$i]['tag']=="REQUEST") {
      array_push($data['requests'], $request);
      $request = null;
    }

    else if($vals[$i]['level']=='2' && $vals[$i]['type']=='open' &&
            $vals[$i]['tag']=="SUGGEST") {
      $data['suggest']=true;
    }

    elseif($vals[$i]['level']=='3' && $vals[$i]['type']=='complete' &&
       $vals[$i]['tag']=="HOST")
      $data['suggest_host']=$vals[$i]['value'];

    elseif($vals[$i]['level']=='3' && $vals[$i]['type']=='complete' &&
       $vals[$i]['tag']=="NAME")
      $data['suggest_name']=$vals[$i]['value'];
  
    elseif($vals[$i]['level']=='3' && $vals[$i]['type']=='complete' &&
       $vals[$i]['tag']=="NAME")
      $request['name']=$vals[$i]['value'];
  
    elseif($vals[$i]['level']=='3' && $vals[$i]['type']=='complete' &&
       $vals[$i]['tag']=="VALUE")
      $request['value']=$vals[$i]['value'];
  
    elseif($vals[$i]['level']=='3' && $vals[$i]['type']=='complete' &&
       $vals[$i]['tag']=="HOST")
      $request['host']=$vals[$i]['value'];
  
    elseif($vals[$i]['level']=='3' && $vals[$i]['type']=='complete' &&
       $vals[$i]['tag']=="PATH")
      $request['path']=$vals[$i]['value'];
  
    elseif($vals[$i]['level']=='3' && $vals[$i]['type']=='complete' &&
       $vals[$i]['tag']=="EXPIRES")
      $request['expires']=$vals[$i]['value'];
  
    elseif($vals[$i]['level']=='3' && $vals[$i]['type']=='complete' &&
       $vals[$i]['tag']=="SECURE")
      $request['secure']=$vals[$i]['value'];
  }

  return $data;
}

function check_ip($ip) {
  global $database;

  if ($ip == "127.0.0.1" || $ip == "localhost")
    return true;

  mysql_query("DELETE FROM ip WHERE timestamp < CURRENT_TIMESTAMP - ".$database['timestamp']);

  $res=mysql_query("SELECT ip FROM ip WHERE ip = \"".mysql_escape_string($ip)."\"");

  if(mysql_num_rows($res) != 0)
    return false;

  mysql_query("REPLACE INTO ip (ip, timestamp) VALUES(\"".mysql_escape_string($ip)."\", CURRENT_TIMESTAMP)");

  return true;
}
?>
